/* $VER: sys/cdefs.h 1.0 (02.03.95) */

#ifndef _CTYPE_H_
#define _CTYPE_H_

	/* is uppercase */
#define	_U	0x01
	/* is lowercase */
#define	_L	0x02
	/* is digit */
#define	_N	0x04
	/* is whitespace */
#define	_S	0x08
	/* is punctuation character */
#define	_P	0x10
	/* is control character */
#define	_C	0x20
	/* is hex letter */
#define	_X	0x40
	/* is blank */
#define	_B	0x80

extern const unsigned char __ctype[];

#define	__isdigit(c)	((__ctype + 1)[c] & _N)
#define	__islower(c)	((__ctype + 1)[c] & _L)
#define	__isspace(c)	((__ctype + 1)[c] & _S)
#define	__ispunct(c)	((__ctype + 1)[c] & _P)
#define	__isupper(c)	((__ctype + 1)[c] & _U)
#define	__isalpha(c)	((__ctype + 1)[c] & (_U|_L))
#define	__isxdigit(c)	((__ctype + 1)[c] & (_N|_X))
#define	__isalnum(c)	((__ctype + 1)[c] & (_U|_L|_N))
#define	__isprint(c)	((__ctype + 1)[c] & (_P|_U|_L|_N|_B))
#define	__isgraph(c)	((__ctype + 1)[c] & (_P|_U|_L|_N))
#define	__iscntrl(c)	((__ctype + 1)[c] & _C)
#define	__isascii(c)	((unsigned)(c) <= 0177)
#define __isiso(c)	((unsigned)(c) <= 0377)
#define	__toupper(c)	(islower(c) ? (c) - 'a' + 'A' : (c))
#define	__tolower(c)	(isupper(c) ? (c) - 'A' + 'a' : (c))
#define	__toascii(c)	((c) & 0177)
#define __toiso(c)	((c) & 0377)

#if defined(__GNUC__) && defined(__OPTIMIZE__)
extern inline int isdigit(int c)	{ return __isdigit(c); }
extern inline int islower(int c)	{ return __islower(c); }
extern inline int isspace(int c)	{ return __isspace(c); }
extern inline int ispunct(int c)	{ return __ispunct(c); }
extern inline int isupper(int c)	{ return __isupper(c); }
extern inline int isalpha(int c)	{ return __isalpha(c); }
extern inline int isxdigit(int c)	{ return __isxdigit(c); }
extern inline int isalnum(int c)	{ return __isalnum(c); }
extern inline int isprint(int c)	{ return __isprint(c); }
extern inline int isgraph(int c)	{ return __isgraph(c); }
extern inline int iscntrl(int c)	{ return __iscntrl(c); }
extern inline int isascii(int c)	{ return __isascii(c); }
extern inline int isiso(int c)		{ return __isiso(c); }
extern inline int toupper(int c)	{ return __toupper(c); }
extern inline int tolower(int c)	{ return __tolower(c); }
extern inline int toascii(int c)	{ return __toascii(c); }
extern inline int toiso(int c)		{ return __toiso(c); }
#else
#define	isdigit(c)	__isdigit(c)
#define	islower(c)	__islower(c)
#define	isspace(c)	__isspace(c)
#define	ispunct(c)	__ispunct(c)
#define	isupper(c)	__isupper(c)
#define	isalpha(c)	__isalpha(c)
#define	isxdigit(c)	__isxdigit(c)
#define	isalnum(c)	__isalnum(c)
#define	isprint(c)	__isprint(c)
#define	isgraph(c)	__isgraph(c)
#define	iscntrl(c)	__iscntrl(c)
#define	isascii(c)	__isascii(c)
#define isiso(c)	__isiso(c)
#define	toupper(c)	__toupper(c)
#define	tolower(c)	__tolower(c)
#define	toascii(c)	__toascii(c)
#define toiso(c)	__toiso(c)
#endif

#endif  /* _CTYPE_H_ */
