/* $VER: string.h 1.0 (02.03.95) */

#ifndef _STRING_H_
#define	_STRING_H_

#ifndef _STDDEF_H_
#include <stddef.h>
#endif

void *memchr (const void *, int, size_t);
int memcmp (const void *, const void *, size_t);
void *memcpy (void *, const void *, size_t);
void *memmove (void *, const void *, size_t);
void *memset (void *, int, size_t);
char *strcat (char *, const char *);
char *strchr (const char *, int);
int strcmp (const char *, const char *);
char *strcpy (char *, const char *);
size_t strcspn (const char *, const char *);
size_t strlen (const char *);
char *strncat (char *, const char *, size_t);
int strncmp (const char *, const char *, size_t);
char *strncpy (char *, const char *, size_t);
char *strpbrk (const char *, const char *);
char *strrchr (const char *, int);
size_t strspn (const char *, const char *);
char *strstr (const char *, const char *);
char *strtok (char *, const char *);
char *strdup (const char *);

int strcasecmp (const char *, const char *);	/* BSD */
char *stpcpy(char *, const char *);		/* Lattice */

#ifdef __SASC_510
int __builtin_memcmp (const void *, const void *, size_t);
void *__builtin_memcpy (void *, const void *, size_t);
void *__builtin_memset (void *, int, size_t);
size_t __builtin_strlen (const char *);
int __builtin_strcmp (const char *, const char *);
char *__builtin_strcpy (char *, const char *);
#define memset __builtin_memset
#define memcmp __builtin_memcmp
#define memcpy __builtin_memcpy
#define strlen __builtin_strlen
#define strcmp __builtin_strcmp
#define strcpy __builtin_strcpy
#endif  /* __SASC_510 */

#endif /* _STRING_H_ */
